/***************************************************************************
                          sqlguiview.cpp  -  description
                             -------------------
    begin                : Sat Apr 14 18:28:06 CEST 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qprinter.h>
#include <qpainter.h>

#include <qcombobox.h>
#include <qheader.h>
#include <qlistview.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qtable.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>

#include <qprogressdialog.h>

#include <klocale.h>
#include <kmenubar.h>

// application specific includes
#include "sqlguiview.h"
#include "sqlguidoc.h"
#include "sqlgui.h"

//#include "waiter.h"

#include <exp_dialog.h>
#include <export_formate.h>

#include <math.h>

#include <iostream>
#include <iomanip>

SqlGuiView::SqlGuiView(QWidget *parent, const char *name) : QWidget(parent, name)
{
  setBackgroundMode(PaletteBase);
  
  KToolBar::BarPosition toolBarPos;

  lastActionDB    = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
  lastActionTab   = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
  lastActionPrim  = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");

	lastActionDB->setLatin1("");
	lastActionTab->setLatin1("");
	lastActionPrim->setLatin1("");
	
  if ( !name )
    setName( "DB_Fenster" );

  setCaption( tr( "Formular" ) );

  // erster Aufruf setzt Breite auf 20:80:
  SqlGuiApp * myApp = (SqlGuiApp *) parentWidget();
  int breite = myApp->width();
  int hoehe  = myApp->height();
  int x=0;
  int x0=0;
  toolBarPos = myApp->toolBar()->barPos();
  int stat_h=0;
  int tool_h= myApp->toolBar()->height();
  int mul = 1;
  if(myApp->viewStatusBar->isChecked()){
    stat_h = myApp->statusBar()->height();
  }
  if( (toolBarPos == KToolBar::Right) || (toolBarPos == KToolBar::Left) ){
    mul = 0;
    if(myApp->viewToolBar->isChecked()) x = myApp->toolBar()->width();
  }
  if(myApp->viewToolBar->isChecked()){
    if( (toolBarPos == KToolBar::Top) || (toolBarPos == KToolBar::Bottom) ) mul = 2;
  }
  breite -= x;
  hoehe=hoehe - stat_h - mul*tool_h;
  int hoehe_mitte = hoehe - 140;
  int breite_links = (int) floor( 0.2 * breite );
  int breite_rechts = breite - breite_links - 5;

	exportdata = 3;
	exportform = 0;

  Kasten = new QFrame( this, "Kasten" );
  Kasten->setFrameShape( QFrame::StyledPanel );
  Kasten->setFrameShadow( QFrame::Raised );

  Line1 = new QSplitter( Kasten, "Line1" );

  QValueList<int> breitenangabe;
  breitenangabe.append(breite_links);
  breitenangabe.append(breite_rechts);

  Line1->setSizes( breitenangabe );
  DATABASES = new QListView( Line1, "DATABASES" );
  DATABASES->addColumn( tr( "Databases" ) );
  DATABASES->addColumn( tr( "Type" ) );
  DATABASES->addColumn( tr( "Pri" ) );
  DATABASES->addColumn( tr( "Extra" ) );
  DATABASES->setFrameShadow( QListView::Sunken );
  DATABASES->setSelectionMode( QListView::Single );
  DATABASES->setColumnWidthMode( 0, QListView::Maximum );
  DATABASES->setRootIsDecorated( true );
  QWhatsThis::add(  DATABASES, tr( "List of Databases" ) );
    
  ResultList = new QTable( Line1, "ResultList" );
  ResultList->setSizePolicy( QSizePolicy( QSizePolicy::Maximum, QSizePolicy::Maximum, false ) );
  ResultList->setSelectionMode( QTable::Single );
  QWhatsThis::add(  ResultList, tr( "Result-List" ) );
  

  sqlEdit = new QMultiLineEdit( Kasten, "sqlEdit" );
  QWhatsThis::add(  sqlEdit, tr( "SQL-Editor: Enter your SQL-statement, select the database (from the upper-left list), which should be affected, and click on OK to submit your query to the server." ) );
  
  sqlEditClear = new QPushButton( Kasten, "sqlEditClear" );
  sqlEditClear->setText( tr( "Clear" ) );
  
  sqlSubmit = new QPushButton( Kasten, "sqlSubmit" );
  sqlSubmit->setText( tr( "OK" ) );
  
  sqlHistory = new QComboBox( FALSE, Kasten, "sqlHistory" );
  QWhatsThis::add(  sqlHistory, tr( "SQL-History: your last SQL-statements are listed here." ) );
  
	whatfile2 = new QFileDialog(this, "Export-File", FALSE);
	whatfile2->hide();
	
  QString * tempStr=new QString("");

  // signals and slots connections
  connect( sqlEditClear, SIGNAL( clicked() ), sqlEdit, SLOT( clear() ) );
  connect( sqlHistory, SIGNAL( activated(const QString&) ), sqlEdit, SLOT( setText(const QString&) ) );
  connect( sqlSubmit, SIGNAL( clicked() ) , this, SLOT( slotEditorQuery() ) );
  connect( sqlSubmit, SIGNAL( clicked() ) , this, SLOT( slotEditorAddHistory() ) );
  connect( DATABASES, SIGNAL( doubleClicked( QListViewItem* ) ) , this, SLOT( slotDoubleClickQuery( QListViewItem* ) ) );
  connect( DATABASES, SIGNAL( rightButtonPressed ( QListViewItem *, const QPoint &, int ) ), this, SLOT( slotDbMenu( QListViewItem *, const QPoint &, int )  ) );
  connect( ResultList, SIGNAL( valueChanged( int, int ) ) , this, SLOT( slotUpdateTable( int, int ) ) );
	
	connect( whatfile2, SIGNAL(fileSelected( const QString & ) ), this, SLOT( slotConfirmOverwrite( const QString & ) ) );
	connect( this, SIGNAL( overwrite( const QString & ) ), this , SLOT(slotSelectExport( const QString & ) ) );
	connect( this, SIGNAL( donotoverwrite( const QString & ) ), this , SLOT( slotExportDlg2() ) );	
}

SqlGuiView::~SqlGuiView()
{
}

SqlGuiDoc *SqlGuiView::getDocument() const
{
  SqlGuiApp *theApp=(SqlGuiApp *) parentWidget();

  return theApp->getDocument();
}

void SqlGuiView::print(QPrinter *pPrinter)
{
  QPainter printpainter;
  printpainter.begin(pPrinter);
	
  // TODO: add your printing code here

  printpainter.end();
}

void SqlGuiView::resizeEvent( QResizeEvent * ){
  
  KToolBar::BarPosition toolBarPos;

  SqlGuiApp * myApp = (SqlGuiApp *) parentWidget();
  int breite = myApp->width();
  int hoehe  = myApp->height();
  int men_h = 0;
  int x=0;
  int x0=0;

  toolBarPos = myApp->toolBar()->barPos();

  int stat_h=0;
  int tool_h= myApp->toolBar()->height();
  int mul = 0;

  if(myApp->viewStatusBar->isChecked()){
    stat_h = myApp->statusBar()->height();
  }

  if( (toolBarPos == KToolBar::Right) || (toolBarPos == KToolBar::Left) ){
    mul = 0;
    if(myApp->viewToolBar->isChecked()) x = myApp->toolBar()->width();
  }
  if(myApp->viewToolBar->isChecked()){
    if( (toolBarPos == KToolBar::Top) || (toolBarPos == KToolBar::Bottom) ) mul = 1;
  }

  if(myApp->menuBar()->isTopLevelMenu()){
    men_h=0;
  } else {
    men_h = myApp->menuBar()->height();
  }


  breite -= x;

  hoehe=hoehe - stat_h - mul*tool_h - men_h;
  int hoehe_mitte = hoehe - 140;

  int breite_links = (int) floor( 0.2 * breite );
  int breite_rechts = breite - breite_links - 5;

  Kasten->setGeometry( QRect( 0, 0, breite, hoehe ) ); 
  sqlEdit->setGeometry( QRect( 0, hoehe_mitte, breite - 80 , 110 ) ); 
  sqlEditClear->setGeometry( QRect( breite - 80, hoehe_mitte, 80, 40 ) ); 
  sqlSubmit->setGeometry( QRect( breite - 80, hoehe_mitte + 40, 80, 70 ) ); 
  sqlHistory->setGeometry( QRect( 0, hoehe_mitte + 110, breite, 30 ) ); 
  Line1->setGeometry( QRect( 0, 0, breite, hoehe_mitte ) ); 
}

QString *SqlGuiView::selectedDB()
{
  QListViewItem * item=NULL;
  QString * data =  new QString;
  cout << "Start..." << endl;

  item = DATABASES->selectedItem();
//  cout << DATABASES << endl;

  if( item ){
    int d = item->depth();
    while(d!=0){
      item=item->parent();
      d=item->depth();	
    }
    data->setLatin1( item->text(0).latin1() );
  }
  cout << "Searched DATABASES..." << endl;

  if(data) return data;
  else return NULL;
}

QString *SqlGuiView::selectedTable()
{
  QListViewItem * item=NULL;
  QString * data =  new QString;
  cout << "Start..." << endl;

  item = DATABASES->selectedItem();

  if( item ){
    int d = item->depth();
    if (d>=1){
      while(d>1){
	item=item->parent();
	d=item->depth();	
      }
      data->setLatin1( item->text(0).latin1() );
    }
  }
  cout << "Searched Tables..." << endl;

  if(data) return data;
  else return NULL;
}

void SqlGuiView::slotDbMenu( QListViewItem * item, const QPoint & pos, int num)
{
  QPopupMenu * menu = new QPopupMenu;
  QString * newbase = new QString(tr("Create Base"));
  QString * newtable = new QString(tr("Create Table"));
  QString * delbase = new QString(tr("Delete Base"));
  QString * deltable = new QString(tr("Delete Table"));
  QString * checktable = new QString(tr("Check Table"));
  QString * optimizetable = new QString(tr("Optimize Table"));
  QString * repairtable = new QString(tr("Repair Table"));
  QString * edittable = new QString(tr("Edit Table"));
  QString * exportdb = new QString(tr("Export"));

  menu->insertItem( *newbase, this, SLOT( slotCreateDB() ) );
  menu->insertItem( *delbase, this, SLOT( slotDeleteBase() ) );
  menu->insertSeparator();
  menu->insertItem( *newtable, this, SLOT( slotCreateTable() )  );
  menu->insertItem( *deltable, this, SLOT( slotDeleteTable() ) );
  menu->insertSeparator();
  menu->insertItem( *checktable, this, SLOT( slotCheckTable() ) );
  menu->insertItem( *optimizetable, this, SLOT( slotOptimizeTable() ) );
  menu->insertItem( *repairtable, this, SLOT( slotRepairTable() ) );
  menu->insertItem( *edittable );
  menu->insertItem( *exportdb, this, SLOT( slotExport() ) );

  menu->exec(pos,num);
  
}

void SqlGuiView::slotCreateDB()
{
  emit( createDb() );
}

void SqlGuiView::deleteBase()
{

  switch( QMessageBox::warning( this, "SqlGui",tr("You are going to delete a database and all it's contents!\nIt will be impossible to restore it!\nYou have been warned...\n"),"Delete", "Cancel", 0, 0, 1 ) )
    {
    case 0:
      {
	emit( deleteDb( this->selectedDB() ) );
	break;
      }
    case 1:
      {    
	break;
      }
    }
}


void SqlGuiView::slotCheckTable()
{
  emit( checkTable(this->selectedDB(), this->selectedTable() ));
}

void SqlGuiView::slotOptimizeTable()
{
  emit( optimizeTable(this->selectedDB(), this->selectedTable() ));
}

void SqlGuiView::slotRepairTable()
{
  emit( repairTable(this->selectedDB(), this->selectedTable() ));
}

void SqlGuiView::slotCreateTable()
{
  emit( createTable() );
}

void SqlGuiView::deleteTable()
{ 
 switch( QMessageBox::warning( this, "SqlGui",tr("You are going to delete a table and all it's contents!\nIt will be impossible to restore it!\nYou have been warned...\n"),"Delete", "Cancel", 0, 0, 1 ) )
    {
    case 0:
      {
	emit( deleteTable( this->selectedDB(), this->selectedTable() ) );
	break;
      }
    case 1:
      {    
	break;
      }
    }
}
void SqlGuiView::slotDeleteTable()
{ 
  this->deleteTable();
}
void SqlGuiView::slotDeleteBase()
{ 
  this->deleteBase();
}

void SqlGuiView::slotUpdateTable(int row, int col)
{
	cout << "Okay, updating the table..." << endl;
	QString * sql = new QString("Update ");
	sql->append( *lastActionTab );
	sql->append( " set " );
	sql->append( ResultList->horizontalHeader()->label(col) );
	sql->append(" = '");
	sql->append( ResultList->text(row, col) );
	sql->append("' where ");
	sql->append( *lastActionPrim );
	sql->append(" LIKE '");
	// Welcher Wert steht in der Spalte mit dem Primary-Key?
	int c = ResultList->numCols();
	int index_col = -1;
	int i = 0;
	for(i = 0; i < c; i++)
	{
		//cout << "I: " << i << " PrimKey: " << lastActionPrim->latin1() << " Head(i): " <<ResultList->horizontalHeader()->label(i).latin1();
		if ( lastActionPrim->compare( ResultList->horizontalHeader()->label(i) ) == 0 )
		{
			index_col = i;
			//cout << " equal " << endl;
		}
		else
		{
			//cout << " not equal " << endl;
		}
	}
	//cout << "Index-Column: " << index_col << endl;
	if(index_col > -1)	sql->append( ResultList->text(row, index_col) );
	sql->append("'");
	cout << "Okay, sending SQL-statement to database " << lastActionDB->latin1() << endl;
	cout << sql->latin1() << endl;
	emit doQuery( lastActionDB, sql );
}

void SqlGuiView::slotUpdateLastAction(QString* db, QString* tab, QString* prim)
{
	lastActionDB->setLatin1(  db->latin1()   );
	lastActionTab->setLatin1(  tab->latin1()  );
	lastActionPrim->setLatin1(  prim->latin1() );
	cout << "Last Action on:" << endl;
	cout << "  DB  : " << db->latin1() << endl;
	cout << "  Tab : " << tab->latin1() << endl;
	cout << "  Prim: " << prim->latin1() << endl;
}

void SqlGuiView::slotUpdateResultList()
{
  int x = ResultList->numCols();
  int y = ResultList->numRows();
  cout << "x = " << x << " y = " << y << endl;
  
  int i=0;
  int j=0;
  int xx=0;
  int yy=0;


//  if (y>2000){
// This suxxxx....!!!!!!!!!!
// eigentlich sollte hier eine Nachricht ausggeben werden... Allerdings kommt die immer erst, 
// NACHDEM der erst spter aufgerufene Delete/clearCell/was-auch-immer beendet wurde...!
//    SqlGuiApp * myApp = (SqlGuiApp *) parentWidget();
//    myApp->slotStatusMsg(i18n("Uhh... very big table... freeing some memory, please wait... "));
//    cout << endl << "Uhh... very big table... freeing some memory, please wait... " << endl << endl;
//  }

  QApplication::setOverrideCursor( Qt::waitCursor );

// Das hier dauert mir zu lange:
//
//  if((x>0)&(y>0)){
//    for(i=0; i<x ; i++)
//      for(j=0; j<y; j++){
//	ResultList->clearCell(j,i);
//      }
//  }
//

// Das Objekt einfach zu DELETEn ist schneller, krashed aber beim dritten mal dieses Programm (dafr gehrt mindestens ein Troll verprgelt)...

  SqlGuiDoc * doc = this->getDocument();
  row_t * result = doc->getFirstRes();
  
  field_t * col = NULL;
  if(result) col = result->feld;
  row_t   * row = result;
  xx=0;
  while(col){
    xx++;
    col=col->next;
  }
  yy=0;
  while(row){
    yy++;
    row=row->next;
  }
  cout << "Rows: " << yy << " Cols: " << xx << endl;

  // Eigentlich sollte es so sein, da man in der QTable einfach die Breitze und Hhe setzen kann, 
  // und dann QT selbstndig den Speicher wieder freigibt. Allerdings scheint mir das nicht ganz koscher.
  // Verwende ich nur 'setNumCols/Rows' und 'setText', dann passiert fogendes:
  // Wenn ich 5 - 6 mal nacheinander eineige groe Tabellen (5000 Zeilen a 50 Spalten, voll mit text und varchar)
  // aufrufe, beginnt mein Rechner sehr schnell zu swappen, und irgendwann wird SqlGui gekilled, weil es zuviel Speicher braucht.

  // Deswegen entferne ich hier alle berflssigen Zeilen/Spalten von Hand. Die Zeilen, die bereits vorhanden sind,
  // knnen natrlich wiederverwendet werden, deswegen wird hier etwas umstndlich abgezhlt.

  // Das ist dann zwar ein ganzes Stck langsamer, als nur 'setNumCols/Rows' und 'setText', dafr fllt es aber den Speicher nicht auf.

  // Alle nicht mehr bentigten Zeilen/Spalten wegwerfen:
  // x  alte breite   y  alte hoehe
  // xx neue breite   yy neue hoehe
  //
  // Vier Flle sind zu beachten:
  //
  //           x       xx
  //  ------------------   
  // |         |        |  
  // |         |        |  
  // |  bleibt | neu    |  
  // |         |        |  
  //  ------------------  y  
  // |         |        |  
  // |  neu    | neu    |  
  // |         |        |  
  // |         |        |  
  //  ------------------  yy
  //
  //
  //
  //           xx       x
  //  ------------------   
  // |         |        |  
  // |  bleibt | weg    |  
  // |         |        |  
  // |         |        |  
  //  ------------------  y  
  // |         |        |  
  // |  neu    |        |  
  // |         |        |  
  // |         |        |  
  //  ------------------  yy
  //
  //
  //
  //           xx       x
  //  ------------------   
  // |         |        |  
  // |  bleibt | weg    |  
  // |         |        |  
  // |         |        |  
  //  ------------------  yy  
  // |         |        |  
  // |  weg    | weg    |  
  // |         |        |  
  // |         |        |  
  //  ------------------  y
  //
  //
  //
  //           x        xx
  //  ------------------   
  // |         |        |  
  // |  bleibt | neu    |  
  // |         |        |  
  // |         |        |  
  //  ------------------  yy  
  // |         |        |  
  // |  weg    |        |  
  // |         |        |  
  // |         |        |  
  //  ------------------  y
  //
  //

	// Zustzlich noch sagen, was wir machen...:
	int tot = 0;
	if (xx < x)
	{
		tot += (x-xx)*y;
		if ( y > yy )
		{
			tot += xx*(y-yy);
		}
	}
	if (( xx > x ) && (y > yy))
	{
		tot += xx*(y-yy);
	}
	
	
	QProgressDialog progress( "Freeing some memory, please wait...", "(ToDo: remove this button)", tot, this, "progress", TRUE );
	progress.setCancelButton(NULL);
	int prg = 0;
	
	
  if( xx < x ){
    for (i=xx; i<x; i++)
      for(j=0; j<y; j++) {ResultList->clearCell(j,i);progress.setProgress(++prg);}

    if ( y > yy ){
      for (i=0; i<xx; i++)
				for(j=yy; j<y; j++) {ResultList->clearCell(j,i);progress.setProgress(++prg);}
    }
  }
  if( xx > x){
    if( y > yy ) {
      for (i=0; i<x; i++)
				for(j=yy; j<y; j++) {ResultList->clearCell(j,i);progress.setProgress(++prg);}
    }
  }
	progress.setProgress(tot);

  // Breite setzen:
  ResultList->setNumCols(xx);
  ResultList->setNumRows(yy);

  SqlGuiApp * myApp = (SqlGuiApp *) parentWidget();
  QString * msg = new QString;
  msg->setNum(yy);
  msg->prepend("Successfull connection... got ");
  msg->append(" rows.");

  myApp->slotStatusMsg(i18n(msg->latin1()));

  QApplication::restoreOverrideCursor();
  if (yy==0)
  {
  	emit gotResult();
  	return;
  }
  QApplication::setOverrideCursor( Qt::waitCursor );

  i=0;
  j=0;

  // Rest einfgen:
  while( result ){
    field_t * column = result->feld;
    i=0;
    while( column ){
      QString Wert;
      Wert.setLatin1( column->value );
      // Ist i > x mssen wir das TableItem neu erzeugen, ebenso wenn j > y ist.
      if( (i>x) || (j>y) ){
				QTableItem * Zelle = new QTableItem(ResultList, QTableItem::OnTyping, Wert);
				ResultList->setItem(j,i,Zelle);
      } else {
				ResultList->setText( j,i,Wert );
				ResultList->updateCell(j,i);
      }
      // ansonsten knnen wir die alten TableItems weiterverwenden.
      column=column->next;
      i++;
    }
    j++;
    result=result->next;
  }

  QApplication::restoreOverrideCursor();
  // Kopf schreiben:
  QHeader * kopf = ResultList->horizontalHeader();
  spalten_t * colu;
  colu = doc->resultCols();
  int v=0;
  while(colu){
    QString * k_name = new QString( colu->name );
    kopf->setLabel(v, *k_name );
    delete k_name;
    ResultList->adjustColumn(v);
    v++;
    colu=colu->next;
  }
  cout << "Sending Clear-Memory-Request..." << endl;
  emit( gotResult() );
  cout << "ResultList should be updated now..." << endl;

}

void SqlGuiView::slotEditorAddHistory()
{
  QString s;
  if(! sqlEdit->text().isEmpty() ){
    s.setLatin1( sqlEdit->text().latin1() );
    sqlHistory->insertItem( s,0);
  }

}

void SqlGuiView::slotEditorQuery()
{
  QString * b = new QString;
  QString * s = new QString;
  QListViewItem * item;


  item = DATABASES->selectedItem();
  if( item ){
    int d = item->depth();
    while(d!=0){
      item=item->parent();
      d=item->depth();	
    }
    b->setLatin1( item->text(0).latin1() );
  }
  if( sqlEdit->text() )s->setLatin1( sqlEdit->text().latin1() );
  emit( doQuery( b, s ) );
}

void SqlGuiView::slotDoubleClickQuery( QListViewItem * item )
{
  QString * b = new QString;
  QString * t = new QString;
  QString s;

  s.setLatin1("Select * From ");

  if( item ){
    int d = item->depth();
    if(d!=1) return;
    item->setOpen(! item->isOpen() );
    t->setLatin1( item->text(0).latin1() );
    s = s.append( *t );
    item=item->parent();
    b->setLatin1( item->text(0).latin1() );
  }

  cout << "Got DoubleClick on " << t->latin1()  << endl;

  emit( doQuery( b, &s ) );
}

void SqlGuiView::slotUpdateMainView(){
  
  base_t * hilf = NULL;
  SqlGuiDoc * doc = this->getDocument();

  hilf = doc->getDBs();
  DATABASES->clear();

  // Datenbanken einfgen:
  while( hilf ){
    QListViewItem * temp = new QListViewItem(DATABASES);
    QString * datum = new QString( hilf->name );

//    cout << "Update Main View: " << hilf->name << endl;

    temp->setText(0,*datum);
    DATABASES->insertItem( temp );
    
    table_t * hilf2 = NULL;
    hilf2 = hilf->table_list;

    delete datum; // hier gekilled
    // Tabellen einfgen:
    while( hilf2 ){
      QString * datum2 = new QString( hilf2->name );
      QListViewItem * temp2 = new QListViewItem( temp );
      temp2->setText(0,*datum2);
      temp->insertItem( temp2 );

      // Spalten einfgen:
      spalten_t * hilf3 = NULL;
      hilf3 = hilf2->spalten_liste;
      delete datum2; // hier gekilled
//      cout << hilf3->name << endl;
      while(hilf3){
	QString * datum3 = new QString( hilf3->name );
	QString * datum4 = new QString( hilf3->type );
	QChar * datum5 = new QChar( hilf3->pri );
//	QString * datum5 = new QString( *dat5 );	
	QString * datum6 = new QString( hilf3->extra_flags );
	QListViewItem * temp3 = new QListViewItem( temp2 );
	temp3->setText(0,*datum3);
	temp3->setText(1,*datum4);
	temp3->setText(2,*datum5);
	temp3->setText(3,*datum6);
	temp2->insertItem( temp3 );
	hilf3=hilf3->next;
	delete datum3; // hier gekilled
      }

      hilf2 = hilf2->next;
    }
    hilf = hilf->next;
  }

  DATABASES->repaint();
  
}

void SqlGuiView::slotExport()
{
	ExportForm* frage = new ExportForm(this, "Export", TRUE, Qt::WType_Modal);

	connect( frage, SIGNAL( exportRequest(int, int) ), this, SLOT(slotExportDlg2( ) ) );
	connect( frage, SIGNAL( exportRequest(int, int) ), this, SLOT(slotSetExport(int, int) ) );
	frage->show();
	
}

void SqlGuiView::slotSetExport(int what, int form)
{
	cout << "checked: " << what << " and " << form << endl;
	exportdata = what;
	
	switch (form){
//		case 0: {exportform = EXCEL;break;}
		case 0: {exportform = TEXT;break;}
		case 1: {exportform = CSV;break;}
		case 2: {exportform = HTML;break;}
		case 3: {exportform = XML;break;}
		case 4: {exportform = POSTSCRIPT;break;}
		case 5: {exportform = TEX;break;}
	}
}

void SqlGuiView::slotExportDlg(int what, int form)
{
}



void SqlGuiView::slotExportDlg2()
{
//	QFileDialog* whatfile2 = new QFileDialog(this, "Export-File", FALSE);
	whatfile2->show();
}


void SqlGuiView::slotConfirmOverwrite(const QString & filename){

	QFile file( filename );
	if ( !file.exists() ){
		emit( overwrite( filename ) );
		cout << "file doesnt exist... creating new one..." << endl;
		return;
	}
	
	if ( file.exists() ){
	cout << "file exists!!!" << endl;
    switch( QMessageBox::information( this, "SqlGui Warning:",
                                      "File exists\n"
                                      "Do you want to overwrite the file?",
                                      "&Yes", "&No", "&Cancel",
                                      0,      // Enter == button 0
                                      2 ) ) { // Escape == button 2
    case 0: {
        emit( overwrite( filename ) );
        cout << "overwrite" << endl;
        break;}
    case 1:
        emit( donotoverwrite( filename ) );
        cout << "not overwrite" << endl;
        break;
    case 2:
        break;
    }
	
	}
}


void SqlGuiView::qtsuxx( const QString & expfile ){
//cout << "BTW: QT suxx!!!" << endl;
}

void SqlGuiView::slotSelectExport( const QString & expfile )
{
	cout << "Exportdata: " << exportdata << " and Exportform: " << exportform << endl;
	
	ExportObj* expo = new ExportObj(this,"Export");
	
	expo->setFormat( exportform );
	
	switch (exportdata)
	{
		case 1:
		{
			// slotExportDB();
		}
		case 2:
		{
			// slotExportTable();
		}
		case 3:
		{
				QTableSelection* selection = new QTableSelection();
				selection = &(ResultList->selection(0));
				int oben = selection->topRow();
				int unten = selection->bottomRow();
				int links = selection->leftCol();
				int rechts = selection->rightCol();
				
				int zeilenOffset = oben;
				int spaltenOffset = links;
				
				cout << "top: " << oben << " bottom: " << unten << " left: " << links << " right: " << rechts << endl;
		
				expo->setFilename( &expfile );
				
				int tot = (unten-oben) * (rechts-links);
				
				QProgressDialog progress( "Preparing data for export", "Abort export", tot, this, "progress", TRUE );
				
				// Alle selektierten Felder zeilenweise durchlaufen
				int prg = 0;
				for (int zeile = oben; zeile <= unten; zeile++){
					for (int spalte = links; spalte <= rechts; spalte++){
						// TODO: Spaltentyp festellen...!!!
						progress.setProgress( prg++ );
						expo->addData(zeile - zeilenOffset, spalte - spaltenOffset, &(ResultList->text(zeile,spalte))  );
					}
					if (progress.wasCancelled() ) break;
				}
				progress.setProgress( tot );
		}
	}
	
	expo->finish();
	delete expo;
}

/*
void SqlGuiView::slotExportDB(QString* db, int format)
{
}
void SqlGuiView::slotExportTable(QString* db, QString* tb, int format)
{
}

void SqlGuiView::slotExportSelection( int row1, int col1, int row2, int col2, int format)
{
}
*/
